const fetch = require('node-fetch');
const querystring = require('querystring');
const apiToken = config.FACEBOOK.API_TOKEN;
const apiEndPoint = config.FACEBOOK.END_POINT;

class facebookService {

  verifyAccessToken(token){
    let query = {
      access_token : apiToken,
      input_token : token
    }

    let url = `${apiEndPoint}/debug_token?${querystring.stringify(query)}`;

    return fetch(url)
      .then(result => result.json())
      .then(json => {
        console.log(json);
        if(json.data && json.data.is_valid) {
          //return user_id if valid
          return json.data.user_id;
        }
        logger.log(json);
        //or else return false
        return false;
      });
  }
}

module.exports = new facebookService();
